! ORDE 3: matriz a=
!   2.00  1.00 -1.00 
!   2.00  0.00  1.00 
!   1.00  2.00  4.00 
!  inv(a)=
!   0.13  0.40 -0.07 
!   0.47 -0.60  0.27 
!  -0.27  0.20  0.13 
!--------------------------------
! ORDE 4: a =
!    1   2   3   4
!   -1   2   0   3
!    4   1   9   5
!    4   3   2   1
! inv(a) =
!    3.08  -2.40  -1.00  -0.12
!   -3.32   2.60   1.00   0.48
!   -2.80   2.00   1.00   0.20
!    3.24  -2.20  -1.00  -0.36
program inversa
real(8),allocatable :: a(:,:),b(:,:)

open(1, file="matriz_orde4.dat", status="old")
read (1,*) n
allocate(a(n,n),b(n,n))
do i = 1, n
  read (1, *) (a(i, j), j = 1, n)
  do j = 1, n
    print '(f6.2,$)', a(i, j)
  end do
  print *, ''  ! para pasar á seguinte liña
end do
close(1)

call inv(a, n, b)

print *, "inv(a)="
do i = 1, n
  do j = 1, n
    print '(f6.2,$)', b(i, j)
  end do
  print *, ''
end do

deallocate(a,b)
stop
end program inversa


!-------------------------------
! Retorna a inversa dunha matriz calculando a descomposición LU con Lapack
subroutine inv(A, n, Ainv)
real(8),intent(in) :: A(n,n)
real(8),intent(out) :: Ainv(n,n)
integer, intent(in) :: n
real(8) :: work(n)  ! work array for LAPACK
integer :: ipiv(n)   ! pivot indices
integer :: info

! procedementos external definidos en Lapack
external DGETRF
external DGETRI

! Almacena A en Ainv para evitar que lapack a sobrescriba
Ainv = A

! DGETRF calcula a factorización LU da matriz usando pivote parcial con intercambio de filas
call DGETRF(n, n, Ainv, n, ipiv, info)
if (info /= 0) stop "error: matriz singular"

! DGETRI calcula a matriz inversa usando a factorización LU calculada por DGETRF.
call DGETRI(n, Ainv, n, ipiv, work, n, info)
if (info /= 0) stop "error en la inversión"

return
end subroutine inv
